Index: trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/ICoordinatesTSPSolutionsVisualizer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/ICoordinatesTSPSolutionsVisualizer.cs	(revision 3107)
+++ trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/ICoordinatesTSPSolutionsVisualizer.cs	(revision 3107)
@@ -0,0 +1,32 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Problems.TSP {
+  /// <summary>
+  /// An interface which represents an operator for visualizing tours of Traveling Salesman Problems using city coordinates.
+  /// </summary>
+  public interface ICoordinatesTSPSolutionsVisualizer : ITSPSolutionsVisualizer {
+    ILookupParameter<DoubleMatrix> CoordinatesParameter { get; }
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/IPathCoordinatesTSPSolutionsVisualizer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/IPathCoordinatesTSPSolutionsVisualizer.cs	(revision 3107)
+++ trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/IPathCoordinatesTSPSolutionsVisualizer.cs	(revision 3107)
@@ -0,0 +1,32 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+
+namespace HeuristicLab.Problems.TSP {
+  /// <summary>
+  /// An interface which represents an operator for visualizing tours of Traveling Salesman Problems given in path representation using city coordinates.
+  /// </summary>
+  public interface IPathCoordinatesTSPSolutionsVisualizer : ICoordinatesTSPSolutionsVisualizer {
+    ILookupParameter<ItemArray<Permutation>> PermutationParameter { get; }
+  }
+}
Index: trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/IPathTSPTourVisualizer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/IPathTSPTourVisualizer.cs	(revision 3097)
+++ 	(revision )
@@ -1,32 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Encodings.PermutationEncoding;
-
-namespace HeuristicLab.Problems.TSP {
-  /// <summary>
-  /// An interface which represents an operator for visualizing tours of Traveling Salesman Problems given in path representation.
-  /// </summary>
-  public interface IPathTSPTourVisualizer : ITSPTourVisualizer {
-    ILookupParameter<Permutation> PermutationParameter { get; }
-  }
-}
Index: trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/ITSPSolutionsVisualizer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/ITSPSolutionsVisualizer.cs	(revision 3107)
+++ trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/ITSPSolutionsVisualizer.cs	(revision 3107)
@@ -0,0 +1,29 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Problems.TSP {
+  /// <summary>
+  /// An interface which represents an operator for visualizing solutions of Traveling Salesman Problems.
+  /// </summary>
+  public interface ITSPSolutionsVisualizer : ISingleObjectiveSolutionsVisualizer { }
+}
Index: trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/ITSPTourVisualizer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.TSP/3.3/Interfaces/ITSPTourVisualizer.cs	(revision 3097)
+++ 	(revision )
@@ -1,33 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Optimization;
-
-namespace HeuristicLab.Problems.TSP {
-  /// <summary>
-  /// An interface which represents an operator for visualizing tours of Traveling Salesman Problems.
-  /// </summary>
-  public interface ITSPTourVisualizer : ISolutionVisualizer {
-    ILookupParameter<DoubleMatrix> CoordinatesParameter { get; }
-  }
-}