Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/AdminClientFactory.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/AdminClientFactory.cs	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/AdminClientFactory.cs	(revision 3112)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/UpdateClientFactory.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/UpdateClientFactory.cs	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/DeploymentService/UpdateClientFactory.cs	(revision 3112)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.Designer.cs	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/LocalPluginManager.Designer.cs	(revision 3112)
@@ -46,5 +46,5 @@
       this.components = new System.ComponentModel.Container();
       System.Windows.Forms.ListViewGroup listViewGroup1 = new System.Windows.Forms.ListViewGroup("Active Plugins", System.Windows.Forms.HorizontalAlignment.Left);
-      System.Windows.Forms.ListViewGroup listViewGroup2 = new System.Windows.Forms.ListViewGroup("Inactive Plugins", System.Windows.Forms.HorizontalAlignment.Left);
+      System.Windows.Forms.ListViewGroup listViewGroup2 = new System.Windows.Forms.ListViewGroup("Disabled Plugins", System.Windows.Forms.HorizontalAlignment.Left);
       this.imageListForLocalItems = new System.Windows.Forms.ImageList(this.components);
       this.localPluginsListView = new HeuristicLab.PluginInfrastructure.Advanced.MultiSelectListView();
@@ -70,6 +70,6 @@
       listViewGroup1.Header = "Active Plugins";
       listViewGroup1.Name = "activePluginsGroup";
-      listViewGroup2.Header = "Inactive Plugins";
-      listViewGroup2.Name = "inactivePluginsGroup";
+      listViewGroup2.Header = "Disabled Plugins";
+      listViewGroup2.Name = "disabledPluginsGroup";
       this.localPluginsListView.Groups.AddRange(new System.Windows.Forms.ListViewGroup[] {
             listViewGroup1,
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.Designer.cs	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.Designer.cs	(revision 3112)
@@ -53,4 +53,9 @@
       this.versionHeader = new System.Windows.Forms.ColumnHeader();
       this.descriptionHeader = new System.Windows.Forms.ColumnHeader();
+      this.radioButton1 = new System.Windows.Forms.RadioButton();
+      this.advancedViewButton = new System.Windows.Forms.RadioButton();
+      this.simpleViewButton = new System.Windows.Forms.RadioButton();
+      this.viewButtonGroupBox = new System.Windows.Forms.GroupBox();
+      this.viewButtonGroupBox.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -63,4 +68,7 @@
       // remotePluginsListView
       // 
+      this.remotePluginsListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
       this.remotePluginsListView.CheckBoxes = true;
       this.remotePluginsListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
@@ -68,5 +76,4 @@
             this.versionHeader,
             this.descriptionHeader});
-      this.remotePluginsListView.Dock = System.Windows.Forms.DockStyle.Fill;
       listViewGroup1.Header = "Products";
       listViewGroup1.Name = "productsGroup";
@@ -79,7 +86,7 @@
             listViewGroup2,
             listViewGroup3});
-      this.remotePluginsListView.Location = new System.Drawing.Point(0, 0);
+      this.remotePluginsListView.Location = new System.Drawing.Point(0, 50);
       this.remotePluginsListView.Name = "remotePluginsListView";
-      this.remotePluginsListView.Size = new System.Drawing.Size(533, 558);
+      this.remotePluginsListView.Size = new System.Drawing.Size(533, 508);
       this.remotePluginsListView.StateImageList = this.imageListForRemoteItems;
       this.remotePluginsListView.SuppressItemCheckedEvents = false;
@@ -104,12 +111,66 @@
       this.descriptionHeader.Width = 250;
       // 
+      // radioButton1
+      // 
+      this.radioButton1.AutoSize = true;
+      this.radioButton1.Location = new System.Drawing.Point(-15, -15);
+      this.radioButton1.Name = "radioButton1";
+      this.radioButton1.Size = new System.Drawing.Size(85, 17);
+      this.radioButton1.TabIndex = 2;
+      this.radioButton1.TabStop = true;
+      this.radioButton1.Text = "radioButton1";
+      this.radioButton1.UseVisualStyleBackColor = true;
+      // 
+      // advancedViewButton
+      // 
+      this.advancedViewButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)));
+      this.advancedViewButton.Appearance = System.Windows.Forms.Appearance.Button;
+      this.advancedViewButton.AutoSize = true;
+      this.advancedViewButton.Location = new System.Drawing.Point(104, 9);
+      this.advancedViewButton.Name = "advancedViewButton";
+      this.advancedViewButton.Size = new System.Drawing.Size(92, 23);
+      this.advancedViewButton.TabIndex = 3;
+      this.advancedViewButton.Text = "Advanced View";
+      this.advancedViewButton.UseVisualStyleBackColor = true;
+      this.advancedViewButton.CheckedChanged += new System.EventHandler(this.advancedViewButton_CheckedChanged);
+      // 
+      // simpleViewButton
+      // 
+      this.simpleViewButton.Appearance = System.Windows.Forms.Appearance.Button;
+      this.simpleViewButton.Checked = true;
+      this.simpleViewButton.Location = new System.Drawing.Point(6, 9);
+      this.simpleViewButton.Name = "simpleViewButton";
+      this.simpleViewButton.Size = new System.Drawing.Size(92, 23);
+      this.simpleViewButton.TabIndex = 3;
+      this.simpleViewButton.TabStop = true;
+      this.simpleViewButton.Text = "Simple View";
+      this.simpleViewButton.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
+      this.simpleViewButton.UseVisualStyleBackColor = true;
+      this.simpleViewButton.CheckedChanged += new System.EventHandler(this.advancedViewButton_CheckedChanged);
+      // 
+      // viewButtonGroupBox
+      // 
+      this.viewButtonGroupBox.Controls.Add(this.advancedViewButton);
+      this.viewButtonGroupBox.Controls.Add(this.simpleViewButton);
+      this.viewButtonGroupBox.Location = new System.Drawing.Point(3, 8);
+      this.viewButtonGroupBox.Name = "viewButtonGroupBox";
+      this.viewButtonGroupBox.Size = new System.Drawing.Size(204, 36);
+      this.viewButtonGroupBox.TabIndex = 5;
+      this.viewButtonGroupBox.TabStop = false;
+      // 
       // RemotePluginInstaller
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.viewButtonGroupBox);
+      this.Controls.Add(this.radioButton1);
       this.Controls.Add(this.remotePluginsListView);
       this.Name = "RemotePluginInstaller";
       this.Size = new System.Drawing.Size(533, 558);
+      this.viewButtonGroupBox.ResumeLayout(false);
+      this.viewButtonGroupBox.PerformLayout();
       this.ResumeLayout(false);
+      this.PerformLayout();
 
     }
@@ -122,4 +183,8 @@
     private System.Windows.Forms.ColumnHeader versionHeader;
     private System.Windows.Forms.ColumnHeader descriptionHeader;
+    private System.Windows.Forms.RadioButton radioButton1;
+    private System.Windows.Forms.RadioButton advancedViewButton;
+    private System.Windows.Forms.RadioButton simpleViewButton;
+    private System.Windows.Forms.GroupBox viewButtonGroupBox;
   }
 }
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/RemotePluginInstaller.cs	(revision 3112)
@@ -30,9 +30,10 @@
 namespace HeuristicLab.PluginInfrastructure.Advanced {
   internal partial class RemotePluginInstaller : UserControl {
+    public event ItemCheckedEventHandler ItemChecked;
+
     private ListViewGroup newPluginsGroup;
     private ListViewGroup productsGroup;
     private ListViewGroup allPluginsGroup;
-
-    public event ItemCheckedEventHandler ItemChecked;
+    private bool showAllPlugins;
 
     public RemotePluginInstaller() {
@@ -105,8 +106,10 @@
       }
 
-      foreach (var plugin in AllPlugins) {
-        var item = CreateListViewItem(plugin);
-        item.Group = allPluginsGroup;
-        remotePluginsListView.Items.Add(item);
+      if (showAllPlugins) {
+        foreach (var plugin in AllPlugins) {
+          var item = CreateListViewItem(plugin);
+          item.Group = allPluginsGroup;
+          remotePluginsListView.Items.Add(item);
+        }
       }
       remotePluginsListView.SuppressItemCheckedEvents = false;
@@ -129,4 +132,16 @@
       return item;
     }
+
+    #region button event handlers
+    private void advancedViewButton_CheckedChanged(object sender, EventArgs e) {
+      if (advancedViewButton.Checked) {
+        showAllPlugins = true;
+      } else {
+        showAllPlugins = false;
+      }
+      UpdateControl();
+    }
+
+    #endregion
 
     #region item checked event handler
@@ -157,7 +172,9 @@
       modifiedItems.Add(FindItemForProduct(product));
       foreach (var plugin in product.Plugins) {
-        var item = FindItemForPlugin(plugin);
-        if (item != null && item.Checked)
-          modifiedItems.Add(item);
+        // there can be multiple entries for a single plugin in different groups
+        foreach (var item in FindItemsForPlugin(plugin)) {
+          if (item != null && item.Checked)
+            modifiedItems.Add(item);
+        }
       }
       remotePluginsListView.UncheckItems(modifiedItems);
@@ -169,7 +186,10 @@
       modifiedItems.Add(FindItemForProduct(product));
       foreach (var plugin in product.Plugins) {
-        var item = FindItemForPlugin(plugin);
-        if (item != null && !item.Checked) {
-          modifiedItems.Add(item);
+        // there can be multiple entries for a single plugin in different groups
+        foreach (var item in FindItemsForPlugin(plugin)) {
+          if (item != null && !item.Checked) {
+            if (!modifiedItems.Contains(item))
+              modifiedItems.Add(item);
+          }
         }
       }
@@ -180,12 +200,15 @@
       // also uncheck all dependent plugins
       List<ListViewItem> modifiedItems = new List<ListViewItem>();
-      modifiedItems.Add(FindItemForPlugin(plugin));
+      modifiedItems.AddRange(FindItemsForPlugin(plugin));
       var dependentPlugins = from otherPlugin in plugins
                              where otherPlugin.Dependencies.Any(dep => dep.Name == plugin.Name && dep.Version == plugin.Version)
                              select otherPlugin;
       foreach (var dependentPlugin in dependentPlugins) {
-        var item = FindItemForPlugin(dependentPlugin);
-        if (item != null && item.Checked) {
-          modifiedItems.Add(item);
+        // there can be multiple entries for a single plugin in different groups
+        foreach (var item in FindItemsForPlugin(dependentPlugin)) {
+          if (item != null && item.Checked) {
+            if (!modifiedItems.Contains(item))
+              modifiedItems.Add(item);
+          }
         }
       }
@@ -197,5 +220,6 @@
         var item = FindItemForProduct(dependentProduct);
         if (item != null && item.Checked) {
-          modifiedItems.Add(item);
+          if (!modifiedItems.Contains(item))
+            modifiedItems.Add(item);
         }
       }
@@ -206,9 +230,12 @@
       // also check all dependencies
       List<ListViewItem> modifiedItems = new List<ListViewItem>();
-      modifiedItems.Add(FindItemForPlugin(plugin));
+      modifiedItems.AddRange(FindItemsForPlugin(plugin));
       foreach (var dep in plugin.Dependencies) {
-        var item = FindItemForPlugin(dep);
-        if (item != null && !item.Checked) {
-          modifiedItems.Add(item);
+        // there can be multiple entries for a single plugin in different groups
+        foreach (ListViewItem item in FindItemsForPlugin(dep)) {
+          if (item != null && !item.Checked) {
+            if (!modifiedItems.Contains(item))
+              modifiedItems.Add(item);
+          }
         }
       }
@@ -222,9 +249,9 @@
 
     #region helper methods
-    private ListViewItem FindItemForPlugin(IPluginDescription plugin) {
+    private IEnumerable<ListViewItem> FindItemsForPlugin(IPluginDescription plugin) {
       return (from item in remotePluginsListView.Items.OfType<ListViewItem>()
               let otherPlugin = item.Tag as IPluginDescription
               where otherPlugin != null && otherPlugin.Name == plugin.Name && otherPlugin.Version == plugin.Version
-              select item).SingleOrDefault();
+              select item);
     }
 
@@ -237,4 +264,5 @@
 
     #endregion
+
   }
 }
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.Designer.cs	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.Designer.cs	(revision 3112)
@@ -1,4 +1,3 @@
-﻿#pragma warning disable 1591
-//------------------------------------------------------------------------------
+﻿//------------------------------------------------------------------------------
 // <auto-generated>
 //     This code was generated by a tool.
@@ -45,5 +44,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("http://servdev.heuristiclab.com/Deployment/Update.svc")]
+        [global::System.Configuration.DefaultSettingValueAttribute("http://servdev.heuristiclab.com/Deployment-3.3/Update.svc")]
         public string UpdateLocation {
             get {
@@ -57,5 +56,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("")]
+        [global::System.Configuration.DefaultSettingValueAttribute("anonymous")]
         public string UpdateLocationUserName {
             get {
@@ -69,5 +68,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("")]
+        [global::System.Configuration.DefaultSettingValueAttribute("GetTheLab!")]
         public string UpdateLocationPassword {
             get {
@@ -81,5 +80,5 @@
         [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("http://servdev.heuristiclab.com/Deployment/Admin.svc")]
+        [global::System.Configuration.DefaultSettingValueAttribute("http://servdev.heuristiclab.com/Deployment-3.3/Admin.svc")]
         public string UpdateLocationAdministrationAddress {
             get {
@@ -92,3 +91,2 @@
     }
 }
-#pragma warning restore 1591
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.settings
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.settings	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.settings	(revision 3112)
@@ -10,14 +10,14 @@
     </Setting>
     <Setting Name="UpdateLocation" Type="System.String" Scope="User">
-      <Value Profile="(Default)">http://servdev.heuristiclab.com/Deployment/Update.svc</Value>
+      <Value Profile="(Default)">http://servdev.heuristiclab.com/Deployment-3.3/Update.svc</Value>
     </Setting>
     <Setting Name="UpdateLocationUserName" Type="System.String" Scope="User">
-      <Value Profile="(Default)" />
+      <Value Profile="(Default)">anonymous</Value>
     </Setting>
     <Setting Name="UpdateLocationPassword" Type="System.String" Scope="User">
-      <Value Profile="(Default)" />
+      <Value Profile="(Default)">GetTheLab!</Value>
     </Setting>
     <Setting Name="UpdateLocationAdministrationAddress" Type="System.String" Scope="User">
-      <Value Profile="(Default)">http://servdev.heuristiclab.com/Deployment/Admin.svc</Value>
+      <Value Profile="(Default)">http://servdev.heuristiclab.com/Deployment-3.3/Admin.svc</Value>
     </Setting>
   </Settings>
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.Designer.cs	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Starter/StarterForm.Designer.cs	(revision 3112)
@@ -47,6 +47,6 @@
       this.components = new System.ComponentModel.Container();
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(StarterForm));
-      System.Windows.Forms.ListViewGroup listViewGroup1 = new System.Windows.Forms.ListViewGroup("Plugin Management", System.Windows.Forms.HorizontalAlignment.Left);
-      System.Windows.Forms.ListViewGroup listViewGroup2 = new System.Windows.Forms.ListViewGroup("Applications", System.Windows.Forms.HorizontalAlignment.Left);
+      System.Windows.Forms.ListViewGroup listViewGroup1 = new System.Windows.Forms.ListViewGroup("Applications", System.Windows.Forms.HorizontalAlignment.Left);
+      System.Windows.Forms.ListViewGroup listViewGroup2 = new System.Windows.Forms.ListViewGroup("Plugin Management", System.Windows.Forms.HorizontalAlignment.Left);
       this.startButton = new System.Windows.Forms.Button();
       this.largeImageList = new System.Windows.Forms.ImageList(this.components);
@@ -88,8 +88,8 @@
             this.versionColumnHeader,
             this.descriptionColumnHeader});
-      listViewGroup1.Header = "Plugin Management";
-      listViewGroup1.Name = "Plugin Management";
-      listViewGroup2.Header = "Applications";
-      listViewGroup2.Name = "Applications";
+      listViewGroup1.Header = "Applications";
+      listViewGroup1.Name = "Applications";
+      listViewGroup2.Header = "Plugin Management";
+      listViewGroup2.Name = "Plugin Management";
       this.applicationsListView.Groups.AddRange(new System.Windows.Forms.ListViewGroup[] {
             listViewGroup1,
@@ -131,5 +131,5 @@
       this.detailsButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
       this.detailsButton.AutoSize = true;
-      this.detailsButton.Image = HeuristicLab.PluginInfrastructure.Properties.Resources.Details;
+      this.detailsButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.Details;
       this.detailsButton.Location = new System.Drawing.Point(68, 511);
       this.detailsButton.Name = "detailsButton";
@@ -144,5 +144,5 @@
       this.listButton.AutoSize = true;
       this.listButton.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
-      this.listButton.Image = HeuristicLab.PluginInfrastructure.Properties.Resources.List;
+      this.listButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.List;
       this.listButton.Location = new System.Drawing.Point(40, 511);
       this.listButton.Name = "listButton";
@@ -157,5 +157,5 @@
       this.largeIconsButton.AutoSize = true;
       this.largeIconsButton.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
-      this.largeIconsButton.Image = HeuristicLab.PluginInfrastructure.Properties.Resources.LargeIcons;
+      this.largeIconsButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.LargeIcons;
       this.largeIconsButton.Location = new System.Drawing.Point(12, 511);
       this.largeIconsButton.Name = "largeIconsButton";
@@ -165,5 +165,5 @@
       this.largeIconsButton.Click += new System.EventHandler(this.largeIconsButton_Click);
       // 
-      // MainForm
+      // StarterForm
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
@@ -176,5 +176,5 @@
       this.Controls.Add(this.startButton);
       this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
-      this.Name = "MainForm";
+      this.Name = "StarterForm";
       this.Text = "HeuristicLab Starter";
       this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MainForm_FormClosing);
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/app.config
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/app.config	(revision 3111)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/app.config	(revision 3112)
@@ -59,5 +59,5 @@
         </bindings>
         <client>
-            <endpoint address="http://servdev.heuristiclab.com/Deployment/Update.svc"
+            <endpoint address="http://servdev.heuristiclab.com/Deployment-3.3/Update.svc"
                 binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IUpdate"
                 contract="HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.IUpdate"
@@ -67,5 +67,5 @@
                 </identity>
             </endpoint>
-            <endpoint address="http://servdev.heuristiclab.com/Deployment/Admin.svc"
+            <endpoint address="http://servdev.heuristiclab.com/Deployment-3.3/Admin.svc"
                 binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IAdmin"
                 contract="HeuristicLab.PluginInfrastructure.Advanced.DeploymentService.IAdmin"
@@ -80,14 +80,14 @@
         <HeuristicLab.PluginInfrastructure.Properties.Settings>
             <setting name="UpdateLocation" serializeAs="String">
-                <value>http://servdev.heuristiclab.com/Deployment/Update.svc</value>
+                <value>http://servdev.heuristiclab.com/Deployment-3.3/Update.svc</value>
             </setting>
             <setting name="UpdateLocationUserName" serializeAs="String">
-                <value />
+                <value>anonymous</value>
             </setting>
             <setting name="UpdateLocationPassword" serializeAs="String">
-                <value />
+                <value>GetTheLab!</value>
             </setting>
             <setting name="UpdateLocationAdministrationAddress" serializeAs="String">
-                <value>http://servdev.heuristiclab.com/Deployment/Admin.svc</value>
+                <value>http://servdev.heuristiclab.com/Deployment-3.3/Admin.svc</value>
             </setting>
         </HeuristicLab.PluginInfrastructure.Properties.Settings>